/*********************************************************
'*                                                       *
'*             920MHz Radio Sample Codes                 *
'*                                                       *
'* ----------------------------------------------------- *
'*    Module   :   radioSend.c                           *
'*    Author   :   Li Zheng                              *
'********************************************************/
#include <msp430x44x.h>

//`l0(920.6MHz)ƑMd13dBm
#define MY_CHANNEL                       0
#define MY_TXPOWER                       13
#define MY_PANID                         0x1504
#define MY_ADDR                          0x0000
#define RF_PAYLOADLENGTH                 11  

//샂[h`              
#define RF_STANDBY                       0x04
#define RF_TRANSMITTER                   0x0C

//SX1231WX^AhX
#define REG_FIFO                         0x00
#define REG_DIOMAPPING1	                 0x25

//SX1231WX^ݒl
#define RF_DIOMAPPING_TX                 0x00

char spiReadReg(char addr);
void spiWriteReg(char addr, char val);

void radioInit(char chan, char power);
void radioMode(char mode);
void radioMakeFrame( char* txFrame );

unsigned short calcCRC16(char *data, char len);

//Mt[쐬vO
void radioMakeFrame( char* txFrame )
{
  //wwb_  								
  txFrame[0] = 0x08;
  txFrame[1] = 0xD0;
  //tB[hRg[
  txFrame[2] = 0x00;
  txFrame[3] = 0xA0;
  //PANID
  txFrame[5] = (char)(MY_PANID & 0xFF);
  txFrame[6] = (char)(MY_PANID >> 8);
  //MAhX
  txFrame[7] = (char)(MY_ADDR & 0xFF);
  txFrame[8] = (char)(MY_ADDR >> 8);
}

//MvO
void radioSend( void )
{
  char txFrame[RF_PAYLOADLENGTH];
  unsigned short crc16;

  //LED|[g
  P1DIR |= BIT0;    
  //RF IC`bv
  radioInit(MY_CHANNEL, MY_TXPOWER);
 
  //Mt[e[v[g쐬 
  radioMakeFrame(txFrame);
 
  for (char seq=0; seq<100; seq++) {
    //V[PXԍ
    txFrame[4] = seq;
    crc16 = calcCRC16(txFrame,RF_PAYLOADLENGTH-2);
    txFrame[RF_PAYLOADLENGTH-2] = (char)(crc16 & 0xFF);
    txFrame[RF_PAYLOADLENGTH-1] = (char)(crc16 >> 8);

    //eXgt[M
    for(char i=0; i<RF_PAYLOADLENGTH; i++){
      spiWriteReg(REG_FIFO,txFrame[i]); 
    }
    
    //M[hɐ؂ւ
    radioMode(RF_TRANSMITTER); 
    //RF ICo̓sPacketSentMɐݒ:
    spiWriteReg(REG_DIOMAPPING1,RF_DIOMAPPING_TX); 
    
    //pPbgt[M܂ő҂
    while(!(P1IN & BIT7)); 
    //ҋ@[hɕA
    radioMode(RF_STANDBY); 
    
    //LED_
    P1OUT ^= BIT0;
    
    //Ԓx
    unsigned short i = 50000;
    while (i--);
  }
}

