/*********************************************************
'*                                                       *
'*                 Radio Sample Codes                    *
'*                                                       *
'* ----------------------------------------------------- *
'*    Module   :   spi.c                                 *
'*    Author   :   Li Zheng                              *
'********************************************************/
#include <msp430x44x.h>

//SPI
void spiInit(void)
{
  //SPI|[g  
  P3DIR |= BIT0;
  P3SEL |= BIT1 | BIT2 | BIT3;
  P3OUT |= BIT0;
  
  //SPI[hݒ: 8rbg,}X^
  U0CTL |= SWRST | SYNC | CHAR | MM;
  //SPINbN=SMCLK,ɐ=0,ʑ=1,3s
  U0TCTL |= CKPH | SSEL0 | SSEL1 | STC;
  
  //{[[g 
  U0BR0 = 0x02;
  U0BR1 = 0x00;
  U0MCTL = 0x00;
  
  //SPIL
  U0ME |= USPIE0; 
  //ݒIA|[gZbg
  U0CTL &= ~SWRST;   
}

char spiReadReg(char addr)
{
  char val;

  //SPIX[uI
  P3OUT &= ~BIT0;
  //ǎAhXM  
  U0TXBUF = addr;
  //SPIʐM҂
  __delay_cycles(24);
  //_~[f[^M    
  U0TXBUF = 0x00;
  //SPIʐM҂
  __delay_cycles(24);
  //f[^ǎ    
  val = U0RXBUF;    
  //SPIX[uII
  P3OUT |= BIT0; 
  return val;
}

void spiWriteReg(char addr, char val)
{
  //SPIX[uI
  P3OUT &= ~BIT0;
  //݃AhXM
  U0TXBUF = (addr | 0x80);
  //SPIʐM҂
  __delay_cycles(24);
  //݃f[^M  
  U0TXBUF = val;
  //SPIʐM҂
  __delay_cycles(24);
  //SPIX[uII
  P3OUT |= BIT0;    
}